<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: list/basic_list.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_48c61abad44e2f181b0a6a33afb59c17.html">list</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">basic_list.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="list_2basic__list_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef BASIC_LIST_H</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define BASIC_LIST_H</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;stdbool.h&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="structlist__node.html">   20</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structlist__node.html">list_node</a></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;{</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="structlist__node.html#a0656e14b4a9d75f88dae0493990af83b">   22</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structlist__node.html">list_node</a>* <a class="code" href="structlist__node.html#a0656e14b4a9d75f88dae0493990af83b">next</a>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;};</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="list_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">   34</a></span>&#160;<span class="keyword">typedef</span> int (*<a class="code" href="list_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a>)(<span class="keywordtype">void</span>* node1, <span class="keywordtype">void</span>* node2);</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="list_2basic__list_8h.html#a47b4e5df00566459624dd2f9628627e2">   35</a></span>&#160;<span class="keyword">typedef</span> int (*<a class="code" href="list_2basic__list_8h.html#a47b4e5df00566459624dd2f9628627e2">list_action_fp</a>)(<span class="keywordtype">void</span>* node);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#ae9f64432b192455f316bf623574037a2">list_insert</a>(<span class="keywordtype">void</span>* ref, <span class="keywordtype">void</span>* <span class="keyword">new</span>, uint_least32_t pos);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keywordtype">void</span> <a class="code" href="list_2basic__list_8h.html#a07a470c76daa82462d543d42cbd1df36">list_insert_after</a>(<span class="keywordtype">void</span>* ref, <span class="keywordtype">void</span>* <span class="keyword">new</span>);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#a1a4ab1f1570ecfceed96664f4a710635">list_insert_sorted</a>(<span class="keywordtype">void</span>* ref, <span class="keywordtype">void</span>* <span class="keyword">new</span>, <a class="code" href="list_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a> cmp);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#ab742b7ea7cf853af670946a956a77192">list_remove</a>(<span class="keywordtype">void</span>* ref, uint_least32_t pos);</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#ae8f481baaa8c6fff21b9d435ad4e3a7b">list_remove_next</a>(<span class="keywordtype">void</span>* ref);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#aea35d033b336bc6e91afe59a63a22596">list_next</a>(<span class="keywordtype">void</span>* ref);</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#a7a9cf3ff042c1c58cf89cc68ccecdfcd">list_prev</a>(<span class="keywordtype">void</span>* ref, <span class="keywordtype">void</span>* node);</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#a329055fb825862188f4108422398c30f">list_last</a>(<span class="keywordtype">void</span>* ref);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#a7da046fc29cdae90ff1f9c59cb9ef702">list_at</a>(<span class="keywordtype">void</span>* ref, uint_least32_t pos);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;int_least32_t <a class="code" href="list_2basic__list_8h.html#afbfd3b3116cdc3fcb38d86d37befabc8">list_node_pos</a>(<span class="keywordtype">void</span>* ref, <span class="keywordtype">void</span>* node);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;uint_least32_t <a class="code" href="list_2basic__list_8h.html#ae1c0f6e3cca52e060f4cce1248089d61">list_length</a>(<span class="keywordtype">void</span>* ref);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keywordtype">void</span>* <a class="code" href="list_2basic__list_8h.html#a440f0519121756b356ecce7fd78993b1">list_sort</a>(<span class="keywordtype">void</span>* ref, <a class="code" href="list_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a> cmp);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keywordtype">void</span> <a class="code" href="list_2basic__list_8h.html#ae8b82bac744eb10143002e21c936795f">list_foreach</a>(<span class="keywordtype">void</span>* ref, <a class="code" href="list_2basic__list_8h.html#a47b4e5df00566459624dd2f9628627e2">list_action_fp</a> action);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;}</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="list_2basic__list_8h_html_a329055fb825862188f4108422398c30f"><div class="ttname"><a href="list_2basic__list_8h.html#a329055fb825862188f4108422398c30f">list_last</a></div><div class="ttdeci">void * list_last(void *ref)</div><div class="ttdef"><b>Definition:</b> basic_list.c:92</div></div>
<div class="ttc" id="list_2basic__list_8h_html_ab742b7ea7cf853af670946a956a77192"><div class="ttname"><a href="list_2basic__list_8h.html#ab742b7ea7cf853af670946a956a77192">list_remove</a></div><div class="ttdeci">void * list_remove(void *ref, uint_least32_t pos)</div><div class="ttdef"><b>Definition:</b> basic_list.c:35</div></div>
<div class="ttc" id="structlist__node_html_a0656e14b4a9d75f88dae0493990af83b"><div class="ttname"><a href="structlist__node.html#a0656e14b4a9d75f88dae0493990af83b">list_node::next</a></div><div class="ttdeci">struct list_node * next</div><div class="ttdef"><b>Definition:</b> basic_list.h:22</div></div>
<div class="ttc" id="list_2basic__list_8h_html_ae1c0f6e3cca52e060f4cce1248089d61"><div class="ttname"><a href="list_2basic__list_8h.html#ae1c0f6e3cca52e060f4cce1248089d61">list_length</a></div><div class="ttdeci">uint_least32_t list_length(void *ref)</div><div class="ttdef"><b>Definition:</b> basic_list.c:137</div></div>
<div class="ttc" id="list_2basic__list_8h_html_ae8f481baaa8c6fff21b9d435ad4e3a7b"><div class="ttname"><a href="list_2basic__list_8h.html#ae8f481baaa8c6fff21b9d435ad4e3a7b">list_remove_next</a></div><div class="ttdeci">void * list_remove_next(void *ref)</div><div class="ttdef"><b>Definition:</b> basic_list.c:48</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a7da046fc29cdae90ff1f9c59cb9ef702"><div class="ttname"><a href="list_2basic__list_8h.html#a7da046fc29cdae90ff1f9c59cb9ef702">list_at</a></div><div class="ttdeci">void * list_at(void *ref, uint_least32_t pos)</div><div class="ttdef"><b>Definition:</b> basic_list.c:105</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a14311ae99d413fd70491ae0b4486acdd"><div class="ttname"><a href="list_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a></div><div class="ttdeci">int(* list_compare_nodes_fp)(void *node1, void *node2)</div><div class="ttdef"><b>Definition:</b> basic_list.h:34</div></div>
<div class="ttc" id="list_2basic__list_8h_html_ae8b82bac744eb10143002e21c936795f"><div class="ttname"><a href="list_2basic__list_8h.html#ae8b82bac744eb10143002e21c936795f">list_foreach</a></div><div class="ttdeci">void list_foreach(void *ref, list_action_fp action)</div><div class="ttdef"><b>Definition:</b> basic_list.c:212</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a47b4e5df00566459624dd2f9628627e2"><div class="ttname"><a href="list_2basic__list_8h.html#a47b4e5df00566459624dd2f9628627e2">list_action_fp</a></div><div class="ttdeci">int(* list_action_fp)(void *node)</div><div class="ttdef"><b>Definition:</b> basic_list.h:35</div></div>
<div class="ttc" id="list_2basic__list_8h_html_aea35d033b336bc6e91afe59a63a22596"><div class="ttname"><a href="list_2basic__list_8h.html#aea35d033b336bc6e91afe59a63a22596">list_next</a></div><div class="ttdeci">void * list_next(void *ref)</div><div class="ttdef"><b>Definition:</b> basic_list.c:65</div></div>
<div class="ttc" id="list_2basic__list_8h_html_afbfd3b3116cdc3fcb38d86d37befabc8"><div class="ttname"><a href="list_2basic__list_8h.html#afbfd3b3116cdc3fcb38d86d37befabc8">list_node_pos</a></div><div class="ttdeci">int_least32_t list_node_pos(void *ref, void *node)</div><div class="ttdef"><b>Definition:</b> basic_list.c:119</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a07a470c76daa82462d543d42cbd1df36"><div class="ttname"><a href="list_2basic__list_8h.html#a07a470c76daa82462d543d42cbd1df36">list_insert_after</a></div><div class="ttdeci">void list_insert_after(void *ref, void *new)</div><div class="ttdef"><b>Definition:</b> basic_list.c:25</div></div>
<div class="ttc" id="structlist__node_html"><div class="ttname"><a href="structlist__node.html">list_node</a></div><div class="ttdef"><b>Definition:</b> basic_list.h:20</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a7a9cf3ff042c1c58cf89cc68ccecdfcd"><div class="ttname"><a href="list_2basic__list_8h.html#a7a9cf3ff042c1c58cf89cc68ccecdfcd">list_prev</a></div><div class="ttdeci">void * list_prev(void *ref, void *node)</div><div class="ttdef"><b>Definition:</b> basic_list.c:73</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a440f0519121756b356ecce7fd78993b1"><div class="ttname"><a href="list_2basic__list_8h.html#a440f0519121756b356ecce7fd78993b1">list_sort</a></div><div class="ttdeci">void * list_sort(void *ref, list_compare_nodes_fp cmp)</div><div class="ttdef"><b>Definition:</b> basic_list.c:188</div></div>
<div class="ttc" id="list_2basic__list_8h_html_a1a4ab1f1570ecfceed96664f4a710635"><div class="ttname"><a href="list_2basic__list_8h.html#a1a4ab1f1570ecfceed96664f4a710635">list_insert_sorted</a></div><div class="ttdeci">void * list_insert_sorted(void *ref, void *new, list_compare_nodes_fp cmp)</div><div class="ttdef"><b>Definition:</b> basic_list.c:155</div></div>
<div class="ttc" id="list_2basic__list_8h_html_ae9f64432b192455f316bf623574037a2"><div class="ttname"><a href="list_2basic__list_8h.html#ae9f64432b192455f316bf623574037a2">list_insert</a></div><div class="ttdeci">void * list_insert(void *ref, void *new, uint_least32_t pos)</div><div class="ttdef"><b>Definition:</b> basic_list.c:6</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
